#ifndef _S3C44B0X_IODIRECT_H_
#define _S3C44B0X_IODIRECT_H_

/**
 * register definitions for SAMSUNG S3C44B0X
 *
 * Copyright (C) 2003 Christian Schulte <schulte@sympat.de>
 *
 */
 
/*******************/
/*** CPU WRAPPER ***/
/*******************/

#define IO_S3C44B0X_SYSCFG         *(volatile unsigned long *)0x01c00000
#define IO_S3C44B0X_NCACHBE0       *(volatile unsigned long *)0x01c00004 /* configuration of non-cachable areas */
#define IO_S3C44B0X_NCACHBE1       *(volatile unsigned long *)0x01c00008 /* configuration of non-cachable areas */
#define IO_S3C44B0X_SBUSCON        *(volatile unsigned long *)0x01c40000 /* bus configuration */

  /*************************/
  /*** MEMORY CONTROLLER ***/
  /*************************/

#define IO_S3C44B0X_BWSCON         *(volatile unsigned long *)0x01c80000 /* Bank size, widthand type of memory */
#define IO_S3C44B0X_BANKCON0       *(volatile unsigned long *)0x01c80004 /* timing and page modes */
#define IO_S3C44B0X_BANKCON1       *(volatile unsigned long *)0x01c80008
#define IO_S3C44B0X_BANKCON2       *(volatile unsigned long *)0x01c8000c
#define IO_S3C44B0X_BANKCON3       *(volatile unsigned long *)0x01c80010
#define IO_S3C44B0X_BANKCON4       *(volatile unsigned long *)0x01c80014
#define IO_S3C44B0X_BANKCON5       *(volatile unsigned long *)0x01c80018
#define IO_S3C44B0X_BANKCON6       *(volatile unsigned long *)0x01c8001c
#define IO_S3C44B0X_BANKCON7       *(volatile unsigned long *)0x01c80020
#define IO_S3C44B0X_REFRESH        *(volatile unsigned long *)0x01c80024 /* refresh timing */
#define IO_S3C44B0X_BANKSIZE       *(volatile unsigned long *)0x01c80028 /* bank sizes 2,4,8,16,32 MB */
#define IO_S3C44B0X_MRSRB6         *(volatile unsigned long *)0x01c8002c /* burst settings, CAS latency */
#define IO_S3C44B0X_MRSRB7         *(volatile unsigned long *)0x01c80030

  /************/
  /*** UART ***/
  /************/
  
#define IO_S3C44B0X_ULCON0         *(volatile unsigned long *)0x01d00000
#define IO_S3C44B0X_UCON0          *(volatile unsigned long *)0x01d00004
#define IO_S3C44B0X_UFCON0         *(volatile unsigned long *)0x01d00008
#define IO_S3C44B0X_UMCON0         *(volatile unsigned long *)0x01d0000c
#define IO_S3C44B0X_UTRSTAT0       *(volatile unsigned long *)0x01d00010
#define IO_S3C44B0X_UERSTAT0       *(volatile unsigned long *)0x01d00014
#define IO_S3C44B0X_UFSTAT0        *(volatile unsigned long *)0x01d00018
#define IO_S3C44B0X_UMSTAT0        *(volatile unsigned long *)0x01d0001c

#ifdef CONFIG_CPU_BIG_ENDIAN
#define IO_S3C44B0X_UTXH0           *(volatile unsigned long *)0x01d00023
#define IO_S3C44B0X_URXH0           *(volatile unsigned long *)0x01d00027
#else
#define IO_S3C44B0X_UTXH0           *(volatile unsigned long *)0x01d00020
#define IO_S3C44B0X_URXH0           *(volatile unsigned long *)0x01d00024
#endif

#define IO_S3C44B0X_UBRDIV0         *(volatile unsigned long *)0x01d00028

#define IO_S3C44B0X_ULCON1          *(volatile unsigned long *)0x01d04000
#define IO_S3C44B0X_UCON1           *(volatile unsigned long *)0x01d04004
#define IO_S3C44B0X_UFCON1          *(volatile unsigned long *)0x01d04008
#define IO_S3C44B0X_UMCON1          *(volatile unsigned long *)0x01d0400c
#define IO_S3C44B0X_UTRSTAT1        *(volatile unsigned long *)0x01d04010
#define IO_S3C44B0X_UERSTAT1        *(volatile unsigned long *)0x01d04014
#define IO_S3C44B0X_UFSTAT1         *(volatile unsigned long *)0x01d04018
#define IO_S3C44B0X_UMSTAT1         *(volatile unsigned long *)0x01d0401c

#ifdef CONFIG_CPU_BIG_ENDIAN
#define IO_S3C44B0X_UTXH1           *(volatile unsigned long *)0x01d04023
#define IO_S3C44B0X_URXH1           *(volatile unsigned long *)0x01d04027
#else
#define IO_S3C44B0X_UTXH1           *(volatile unsigned long *)0x01d04020
#define IO_S3C44B0X_URXH1           *(volatile unsigned long *)0x01d04024
#endif

#define IO_S3C44B0X_UBRDIV1         *(volatile unsigned long *)0x01d04028

  /***********/
  /*** SIO ***/
  /***********/

#define IO_S3C44B0X_SIOCON          *(volatile unsigned long *)0x01d14000
#define IO_S3C44B0X_SIODAT          *(volatile unsigned long *)0x01d14004
#define IO_S3C44B0X_SBRDR           *(volatile unsigned long *)0x01d14008
#define IO_S3C44B0X_IVTCNT          *(volatile unsigned long *)0x01d1400c
#define IO_S3C44B0X_DCNTZ           *(volatile unsigned long *)0x01d14010

  /****************************/
  /*** IIS (Inter IC Sound) ***/
  /****************************/

#define IO_S3C44B0X_IISCON          *(volatile unsigned long *)0x01d18000
#define IO_S3C44B0X_IISMOD          *(volatile unsigned long *)0x01d18004
#define IO_S3C44B0X_IISPSR          *(volatile unsigned long *)0x01d18008
#define IO_S3C44B0X_IISFCON         *(volatile unsigned long *)0x01d1800c
#define IO_S3C44B0X_IISFIF          *(volatile unsigned long *)0x01d18010

  /*****************/
  /*** I/O ports ***/
  /*****************/

#define IO_S3C44B0X_PCONA            *(volatile unsigned long *)0x01d20000
#define IO_S3C44B0X_PDATA            *(volatile unsigned long *)0x01d20004
#define IO_S3C44B0X_PCONB            *(volatile unsigned long *)0x01d20008
#define IO_S3C44B0X_PDATB            *(volatile unsigned long *)0x01d2000c

#define IO_S3C44B0X_PCONC           *(volatile unsigned long *)0x01d20010
#define IO_S3C44B0X_PDATC           *(volatile unsigned long *)0x01d20014
#define IO_S3C44B0X_PUPC            *(volatile unsigned long *)0x01d20018
#define IO_S3C44B0X_PCOND           *(volatile unsigned long *)0x01d2001c
#define IO_S3C44B0X_PDATD           *(volatile unsigned long *)0x01d20020
#define IO_S3C44B0X_PUPD            *(volatile unsigned long *)0x01d20024
#define IO_S3C44B0X_PCONE           *(volatile unsigned long *)0x01d20028
#define IO_S3C44B0X_PDATE           *(volatile unsigned long *)0x01d2002c
#define IO_S3C44B0X_PUPE            *(volatile unsigned long *)0x01d20030
#define IO_S3C44B0X_PCONF           *(volatile unsigned long *)0x01d20034
#define IO_S3C44B0X_PDATF           *(volatile unsigned long *)0x01d20038
#define IO_S3C44B0X_PUPF            *(volatile unsigned long *)0x01d2003c
#define IO_S3C44B0X_PCONG           *(volatile unsigned long *)0x01d20040
#define IO_S3C44B0X_PDATG           *(volatile unsigned long *)0x01d20044
#define IO_S3C44B0X_PUPG            *(volatile unsigned long *)0x01d20048
#define IO_S3C44B0X_SPUCR           *(volatile unsigned long *)0x01d2004c

  /***************************/
  /*** external interrupts ***/
  /***************************/

#define IO_S3C44B0X_EXTINT          *(volatile unsigned long *)0x01d20050
#define IO_S3C44B0X_EXTINTPND       *(volatile unsigned long *)0x01d20054

  /**********************/
  /*** WATCHDOG TIMER ***/
  /**********************/

#define IO_S3C44B0X_WTCON            *(volatile unsigned long *)0x01d30000
#define IO_S3C44B0X_WTDAT            *(volatile unsigned long *)0x01d30004
#define IO_S3C44B0X_WTCNT            *(volatile unsigned long *)0x01d30008

  /*********************/
  /*** A/D CONVERTER ***/
  /*********************/

#define IO_S3C44B0X_ADCCON            *(unsigned long *)0x01d40000
#define IO_S3C44B0X_ADCPSR            *(unsigned long *)0x01d40004
#define IO_S3C44B0X_ADCDAT            *(unsigned long *)0x01d40008

  /*****************/
  /*** PWM TIMER ***/
  /*****************/

#define IO_S3C44B0X_TCFG0          *(volatile unsigned long *)0x01d50000 /* prescaler configuration */
#define IO_S3C44B0X_TCFG1          *(volatile unsigned long *)0x01d50004 /* MUX-input for PWM and DMA */
#define IO_S3C44B0X_TCON           *(volatile unsigned long *)0x01d50008 /* timer control register (start/stop, PWM-out, auto-reload, dead-zone) */
#define IO_S3C44B0X_TCNTB0         *(volatile unsigned long *)0x01d5000c /* timer counter "buffer" register (read-write) to update the timer counter */
#define IO_S3C44B0X_TCMPB0         *(volatile unsigned long *)0x01d50010 /* timer compare register */
#define IO_S3C44B0X_TCNTO0         *(volatile unsigned long *)0x01d50014 /* timer counter "observation" register (real counter value, read-only) */
#define IO_S3C44B0X_TCNTB1         *(volatile unsigned long *)0x01d50018
#define IO_S3C44B0X_TCMPB1         *(volatile unsigned long *)0x01d5001c
#define IO_S3C44B0X_TCNTO1         *(volatile unsigned long *)0x01d50020
#define IO_S3C44B0X_TCNTB2         *(volatile unsigned long *)0x01d50024
#define IO_S3C44B0X_TCMPB2         *(volatile unsigned long *)0x01d50028
#define IO_S3C44B0X_TCNTO2         *(volatile unsigned long *)0x01d5002c
#define IO_S3C44B0X_TCNTB3         *(volatile unsigned long *)0x01d50030
#define IO_S3C44B0X_TCMPB3         *(volatile unsigned long *)0x01d50034
#define IO_S3C44B0X_TCNTO3         *(volatile unsigned long *)0x01d50038
#define IO_S3C44B0X_TCNTB4         *(volatile unsigned long *)0x01d5003c
#define IO_S3C44B0X_TCMPB4         *(volatile unsigned long *)0x01d50040
#define IO_S3C44B0X_TCNTO4         *(volatile unsigned long *)0x01d50044
#define IO_S3C44B0X_TCNTB5         *(volatile unsigned long *)0x01d50048
#define IO_S3C44B0X_TCNTO5         *(volatile unsigned long *)0x01d5004c

  /***********/
  /*** IIC ***/
  /***********/

#define IO_S3C44B0X_IICCON          *(volatile unsigned long *)0x01d60000
#define IO_S3C44B0X_IICSTAT         *(volatile unsigned long *)0x01d60004
#define IO_S3C44B0X_IICADD          *(volatile unsigned long *)0x01d60008
#define IO_S3C44B0X_IICDS           *(volatile unsigned long *)0x01d6000c

  /***********/
  /*** RTC ***/
  /***********/

#define IO_S3C44B0X_RTCCON         *(volatile unsigned long *)0x01d70040
#define IO_S3C44B0X_RTCALM         *(volatile unsigned long *)0x01d70050
#define IO_S3C44B0X_ALMSEC         *(volatile unsigned long *)0x01d70054
#define IO_S3C44B0X_ALMMIN         *(volatile unsigned long *)0x01d70058
#define IO_S3C44B0X_ALMHOUR        *(volatile unsigned long *)0x01d7005c
#define IO_S3C44B0X_ALMDAY         *(volatile unsigned long *)0x01d70060
#define IO_S3C44B0X_ALMMON         *(volatile unsigned long *)0x01d70064
#define IO_S3C44B0X_ALMYEAR        *(volatile unsigned long *)0x01d70068
#define IO_S3C44B0X_RTCRST         *(volatile unsigned long *)0x01d7006c
#define IO_S3C44B0X_BCDSEC         *(volatile unsigned long *)0x01d70070
#define IO_S3C44B0X_BCDMIN         *(volatile unsigned long *)0x01d70074
#define IO_S3C44B0X_BCDHOUR        *(volatile unsigned long *)0x01d70078
#define IO_S3C44B0X_BCDDAY         *(volatile unsigned long *)0x01d7007c
#define IO_S3C44B0X_BCDDATE        *(volatile unsigned long *)0x01d70080
#define IO_S3C44B0X_BCDMON         *(volatile unsigned long *)0x01d70084
#define IO_S3C44B0X_BCDYEAR        *(volatile unsigned long *)0x01d70088
#define IO_S3C44B0X_TICINT         *(volatile unsigned long *)0x01d7008c

  /********************************/
  /*** CLOCK & POWER MANAGEMENT ***/
  /********************************/

#define IO_S3C44B0X_PLLCON         *(volatile unsigned long *)0x01d80000
#define IO_S3C44B0X_CLKCON         *(volatile unsigned long *)0x01d80004
#define IO_S3C44B0X_CLKSLOW        *(volatile unsigned long *)0x01d80008
#define IO_S3C44B0X_LOCKTIME       *(volatile unsigned long *)0x01d8000c

  /****************************/
  /*** INTERRUPT CONTROLLER ***/
  /****************************/

#define IO_S3C44B0X_INTCON         *(volatile unsigned long *)0x01e00000
#define IO_S3C44B0X_INTPND         *(volatile unsigned long *)0x01e00004
#define IO_S3C44B0X_INTMOD         *(volatile unsigned long *)0x01e00008
#define IO_S3C44B0X_INTMSK         *(volatile unsigned long *)0x01e0000c
#define IO_S3C44B0X_I_PSLV         *(volatile unsigned long *)0x01e00010
#define IO_S3C44B0X_I_PMST         *(volatile unsigned long *)0x01e00014
#define IO_S3C44B0X_I_CSLV         *(volatile unsigned long *)0x01e00018
#define IO_S3C44B0X_I_CMST         *(volatile unsigned long *)0x01e0001c
#define IO_S3C44B0X_I_ISPR         *(volatile unsigned long *)0x01e00020
#define IO_S3C44B0X_I_ISPC         *(volatile unsigned long *)0x01e00024
#define IO_S3C44B0X_F_ISPR         *(volatile unsigned long *)0x01e00038
#define IO_S3C44B0X_F_ISPC         *(volatile unsigned long *)0x01e0003c

  /***********/
  /*** DMA ***/
  /***********/

#define IO_S3C44B0X_ZDCON0         *(volatile unsigned long *)0x01e80000
#define IO_S3C44B0X_ZDISRC0        *(volatile unsigned long *)0x01e80004
#define IO_S3C44B0X_ZDIDES0        *(volatile unsigned long *)0x01e80008
#define IO_S3C44B0X_ZDICNT0        *(volatile unsigned long *)0x01e8000c
#define IO_S3C44B0X_ZDCSRC0        *(volatile unsigned long *)0x01e80010
#define IO_S3C44B0X_ZDCDES0        *(volatile unsigned long *)0x01e80014
#define IO_S3C44B0X_ZDCCNT0        *(volatile unsigned long *)0x01e80018
#define IO_S3C44B0X_ZDCON1         *(volatile unsigned long *)0x01e80020
#define IO_S3C44B0X_ZDISRC1        *(volatile unsigned long *)0x01e80024
#define IO_S3C44B0X_ZDIDES1        *(volatile unsigned long *)0x01e80028
#define IO_S3C44B0X_ZDICNT1        *(volatile unsigned long *)0x01e8002c
#define IO_S3C44B0X_ZDCSRC1        *(volatile unsigned long *)0x01e80030
#define IO_S3C44B0X_ZDCDES1        *(volatile unsigned long *)0x01e80034
#define IO_S3C44B0X_ZDCCNT1        *(volatile unsigned long *)0x01e80038

#define IO_S3C44B0X_BDCON0         *(volatile unsigned long *)0x01f80000
#define IO_S3C44B0X_BDISRC0        *(volatile unsigned long *)0x01f80004
#define IO_S3C44B0X_BDIDES0        *(volatile unsigned long *)0x01f80008
#define IO_S3C44B0X_BDICNT0        *(volatile unsigned long *)0x01f8000c
#define IO_S3C44B0X_BDCSRC0        *(volatile unsigned long *)0x01f80010
#define IO_S3C44B0X_BDCDES0        *(volatile unsigned long *)0x01f80014
#define IO_S3C44B0X_BDCCNT0        *(volatile unsigned long *)0x01f80018
#define IO_S3C44B0X_BDCON1         *(volatile unsigned long *)0x01f80020
#define IO_S3C44B0X_BDISRC1        *(volatile unsigned long *)0x01f80024
#define IO_S3C44B0X_BDIDES1        *(volatile unsigned long *)0x01f80028
#define IO_S3C44B0X_BDICNT1        *(volatile unsigned long *)0x01f8002c
#define IO_S3C44B0X_BDCSRC1        *(volatile unsigned long *)0x01f80030
#define IO_S3C44B0X_BDCDES1        *(volatile unsigned long *)0x01f80034
#define IO_S3C44B0X_BDCCNT1        *(volatile unsigned long *)0x01f80038


/*********************
 *   LCD controller  *
 *********************/
#define IO_S3C44B0X_LCD_MEM        *(volatile unsigned long *)0x0c060000

#define IO_S3C44B0X_LCDCON1        *(volatile unsigned long *)0x01f00000
#define IO_S3C44B0X_LCDCON2        *(volatile unsigned long *)0x01f00004
#define IO_S3C44B0X_LCDCON3        *(volatile unsigned long *)0x01f00040
#define IO_S3C44B0X_LCDSADDR1      *(volatile unsigned long *)0x01f00008
#define IO_S3C44B0X_LCDSADDR2      *(volatile unsigned long *)0x01f0000c
#define IO_S3C44B0X_LCDSADDR3      *(volatile unsigned long *)0x01f00010

#define IO_S3C44B0X_REDLUT         *(volatile unsigned long *)0x01f00014
#define IO_S3C44B0X_GREENLUT       *(volatile unsigned long *)0x01f00018
#define IO_S3C44B0X_BLUELUT        *(volatile unsigned long *)0x01f0001c
#define IO_S3C44B0X_DP1_2          *(volatile unsigned long *)0x01f00020
#define IO_S3C44B0X_DP4_7          *(volatile unsigned long *)0x01f00024
#define IO_S3C44B0X_DP3_5          *(volatile unsigned long *)0x01f00028
#define IO_S3C44B0X_DP2_3          *(volatile unsigned long *)0x01f0002c
#define IO_S3C44B0X_DP5_7          *(volatile unsigned long *)0x01f00030
#define IO_S3C44B0X_DP3_4          *(volatile unsigned long *)0x01f00034
#define IO_S3C44B0X_DP4_5          *(volatile unsigned long *)0x01f00038
#define IO_S3C44B0X_DP6_7          *(volatile unsigned long *)0x01f0003c
#define IO_S3C44B0X_DITHMODE       *(volatile unsigned long *)0x01f00044

#endif /* _S3C44B0X_IODIRECT_H_ */
