/********************************************
 *
 * File: include/linux/s3c44b0x_lcd.h
 * 
 * Description: S3C44B0X lcd ioctl header
 *
 * Author: Martin Siu, EmSoft Ltd
 *
 * History: 20 Mar 2004 - new
 *
 ********************************************/

#ifndef S3C44B0X_LCD_H
#define S3C44B0X_LCD_H

#include <linux/ioctl.h>


/*
 * Device driver magic
 */
#define S3C44B0X_LCD_IOC_MAGIC    'l'

/*
 * IO control command
 */
#define S3C44B0X_LCD_IOC_GET_FRAMEBUFFER    _IOR(S3C44B0X_LCD_IOC_MAGIC, 1, unsigned long)
#define S3C44B0X_LCD_IOC_GET_CONTRAST       _IOR(S3C44B0X_LCD_IOC_MAGIC, 2, unsigned short)
#define S3C44B0X_LCD_IOC_SET_CONTRAST       _IOW(S3C44B0X_LCD_IOC_MAGIC, 3, unsigned short)
#define S3C44B0X_LCD_IOC_GET_BACKLIGHT      _IOR(S3C44B0X_LCD_IOC_MAGIC, 4, unsigned short)
#define S3C44B0X_LCD_IOC_SET_BACKLIGHT      _IOW(S3C44B0X_LCD_IOC_MAGIC, 5, unsigned short)
#define S3C44B0X_LCD_IOC_GET_POWER_STATE    _IOR(S3C44B0X_LCD_IOC_MAGIC, 6, unsigned long)
#define S3C44B0X_LCD_IOC_SET_POWER_STATE    _IOW(S3C44B0X_LCD_IOC_MAGIC, 7, unsigned long)

#define S3C44B0X_LCD_IOC_MAXNR    7


#endif // S3C44B0X_LCD
