#define CONFIG_8MB_DRAM

.section ".text.init",#alloc,#execinstr
		.type	start, #function
        
        b       start                       // address 0x00
        ldr     pc, vector_undefinstr       // address 0x04 
        ldr     pc, vector_swi              // address 0x08 
        ldr     pc, vector_prefetch_abort   // address 0x0c 
        ldr     pc, vector_data_abort       // address 0x10 
        ldr     pc, vector_addr_excpt       // address 0x14 
        ldr     pc, vector_irq              // address 0x18 
        ldr     pc, vector_fiq              // address 0x1c       

vector_undefinstr:      .long 0x0c000004
vector_swi:             .long 0x0c000008
vector_prefetch_abort:  .long 0x0c00000c
vector_data_abort:      .long 0x0c000010
vector_addr_excpt:      .long 0x0c000014
vector_irq:             .long 0x0c000018
vector_fiq:             .long 0x0c00001c

start:
		mov	    r0, #0xd3	        // F_BIT | I_BIT | MODE_SVC, make sure svc mode
		msr	    cpsr_c, r0			// and all irqs disabled
        
        ldr     r0, WTCON
        ldr     r1, WTCON_val
        str     r1, [r0]

        ldr     r0, SYSCFG
        ldr     r1, SYSCFG_val
        str     r1, [r0]

        ldr     r0, NCACHBE0
        ldr     r1, NCACHBE0_val
        str     r1, [r0]
        
        ldr     r0, NCACHBE1
        ldr     r1, NCACHBE1_val
        str     r1, [r0]

        ldr     r0, PCONA
        ldr     r1, PCONA_val
        str     r1, [r0]

        ldr     r0, PCONB
        ldr     r1, PCONB_val
        str     r1, [r0]

        ldr     r0, PDATB
        ldr     r1, PDATB_val
        str     r1, [r0]

        ldr     r0, PCONC
        ldr     r1, PCONC_val
        str     r1, [r0]

	    ldr     r0, PDATC
        ldr     r1, PDATC_val
        str     r1, [r0]

	    ldr     r0, PUPC
        ldr     r1, PUPC_val
        str     r1, [r0]

        ldr     r0, PCOND
        ldr     r1, PCOND_val
        str     r1, [r0]

        ldr     r0, PUPD
        ldr     r1, PUPD_val
        str     r1, [r0]

        ldr     r0, PCONE
        ldr     r1, PCONE_val
        str     r1, [r0]

	    ldr     r0, PDATE
        ldr     r1, PDATE_val
        str     r1, [r0]

	    ldr     r0, PUPE
        ldr     r1, PUPE_val
        str     r1, [r0]

        ldr     r0, PCONF
        ldr     r1, PCONF_val
        str     r1, [r0]

   	    ldr     r0, PDATF
        ldr     r1, PDATF_val
        str     r1, [r0]

	    ldr     r0, PUPF
        ldr     r1, PUPF_val
        str     r1, [r0]

        ldr     r0, PCONG
        ldr     r1, PCONG_val
        str     r1, [r0]

        ldr     r0, PUPG
        ldr     r1, PUPG_val
        str     r1, [r0]

        ldr     r0, SPUCR
        ldr     r1, SPUCR_val
        str     r1, [r0]
        
        ldr     r0, EXTINT
        ldr     r1, EXTINT_val
        str     r1, [r0]   

        ldr     r0, INTMSK
        ldr     r1, INTMSK_val
        str     r1, [r0]   
        
        ldr     r0, LOCKTIME
        ldr     r1, LOCKTIME_val
        str     r1, [r0]   

        ldr     r0, PLLCON
        ldr     r1, PLLCON_val
        str     r1, [r0]   

        ldr     r0, CLKCON
        ldr     r1, CLKCON_val
        str     r1, [r0]   
        
        ldr     r0, BWSCON
        ldr     r1, BWSCON_val
        str     r1, [r0]   
        
        ldr     r0, BANKCON0
        ldr     r1, BANKCON0_val
        str     r1, [r0]
        
        ldr     r0, BANKCON1
        ldr     r1, BANKCON1_val
        str     r1, [r0]
        
        ldr     r0, BANKCON2
        ldr     r1, BANKCON2_val
        str     r1, [r0]
        
        ldr     r0, BANKCON3
        ldr     r1, BANKCON3_val
        str     r1, [r0]
        
        ldr     r0, BANKCON4
        ldr     r1, BANKCON4_val
        str     r1, [r0]
        
        ldr     r0, BANKCON5
        ldr     r1, BANKCON5_val
        str     r1, [r0]
        
        ldr     r0, BANKCON6
        ldr     r1, BANKCON6_val
        str     r1, [r0]

        ldr     r0, BANKCON7
        ldr     r1, BANKCON7_val
        str     r1, [r0]

        ldr     r0, REFRESH
        ldr     r1, REFRESH_val
        str     r1, [r0]

        ldr     r0, BANKSIZE
        ldr     r1, BANKSIZE_val
        str     r1, [r0]

        ldr     r0, MRSRB6
        ldr     r1, MRSRB6_val
        str     r1, [r0]

        ldr     r0, MRSRB7
        ldr     r1, MRSRB7_val
        str     r1, [r0]
        
copy_kernel:
        ldr     r0, kernel_addr
        ldr     r1, sdram_start
        ldr     r2, end_of_rom
copy_kernel_to_sdram:
        cmp     r0, r2
        ldrcc   r3, [r0], #4
        strcc   r3, [r1], #4
        bcc     copy_kernel_to_sdram
        
jump_to_sdram:
        mov     r0, #0
        mov     r1, #0
        mov     fp, #0
        ldr		r14, sdram_start
	    mov		pc, r14         // jump to sdram

// This is our memory map for 2MB Flash ROM
//-------------------------------------------------
//
// romfs            0x00100000--0x001fffff (1024k)
//
//-------------------------------------------------
//
// linux kernel     0x00001000--0x000fffff (1020k)
//
//-------------------------------------------------
//
// romboot          0x00000000--0x00000fff (4k)
//
//-------------------------------------------------

start_of_rom:       .long 0x00000000
end_of_rom:         .long 0x00200000

sdram_start:        .long 0x0c000000
romboot_addr:       .long 0x00000000
romboot_size:       .long 0x00001000
kernel_addr:        .long 0x00001000
kernel_size:        .long 0x001ff000

SYSCFG:             .long 0x01c00000
NCACHBE0:           .long 0x01c00004
NCACHBE1:           .long 0x01c00008
BWSCON:             .long 0x01c80000
BANKCON0:           .long 0x01c80004
BANKCON1:           .long 0x01c80008
BANKCON2:           .long 0x01c8000c
BANKCON3:           .long 0x01c80010
BANKCON4:           .long 0x01c80014
BANKCON5:           .long 0x01c80018
BANKCON6:           .long 0x01c8001c
BANKCON7:           .long 0x01c80020
REFRESH:            .long 0x01c80024
BANKSIZE:           .long 0x01c80028
MRSRB6:             .long 0x01c8002c
MRSRB7:             .long 0x01c80030
PLLCON:             .long 0x01d80000
CLKCON:             .long 0x01d80004
LOCKTIME:           .long 0x01d8000c
WTCON:              .long 0x01d30000
PCONA:              .long 0x01d20000
PDATA:              .long 0x01d20004
PCONB:              .long 0x01d20008
PDATB:              .long 0x01d2000c
PCONC:              .long 0x01d20010
PDATC:              .long 0x01d20014
PUPC:               .long 0x01d20018
PCOND:              .long 0x01d2001c
PDATD:              .long 0x01d20020
PUPD:               .long 0x01d20024
PCONE:              .long 0x01d20028
PDATE:              .long 0x01d2002c
PUPE:               .long 0x01d20030
PCONF:              .long 0x01d20034
PDATF:              .long 0x01d20038
PUPF:               .long 0x01d2003c
PCONG:              .long 0x01d20040
PDATG:              .long 0x01d20044
PUPG:               .long 0x01d20048
SPUCR:              .long 0x01d2004c
EXTINT:             .long 0x01d20050
INTPND:             .long 0x01e00004   
INTMOD:             .long 0x01e00008   
INTMSK:             .long 0x01e0000c

SYSCFG_val:         .long 0xe           // enable writer buffer, full cache enable, stall disable
NCACHBE0_val:       .long 0x80002000    // bank1, 2, 3 area
NCACHBE1_val:       .long 0x00000000    
BWSCON_val:         .long 0x11110112
BANKCON0_val:       .long 0x600
BANKCON1_val:       .long 0x7ffc
BANKCON2_val:       .long 0x7ffc
BANKCON3_val:       .long 0x7ffc
BANKCON4_val:       .long 0x7ffc
BANKCON5_val:       .long 0x7ffc
BANKCON7_val:       .long 0x18000
REFRESH_val:        .long 0x82062b
#if defined(CONFIG_32MB_DRAM)
BANKCON6_val:       .long 0x18001
BANKSIZE_val:       .long 0x10
#elif defined(CONFIG_16MB_DRAM)
BANKCON6_val:       .long 0x18001
BANKSIZE_val:       .long 0x17
#elif defined(CONFIG_8MB_DRAM)
BANKCON6_val:       .long 0x18000
BANKSIZE_val:       .long 0x16
#elif defined(CONFIG_2MB_DRAM)
BANKCON6_val:       .long 0x18000
BANKSIZE_val:       .long 0x14
#else
#error "invalid sdram config"
#endif
MRSRB6_val:         .long 0x20
MRSRB7_val:         .long 0x20
PLLCON_val:         .long 0x3a031       // Fout at 66Mhz
CLKCON_val:         .long 0x7ff8
LOCKTIME_val:       .long 0xfff         // Set clock control register, EX) count = t_lock * Fin (t_lock=200us, Fin=10MHz) = 2000
WTCON_val:          .long 0x0           // watch dog disable
PCONA_val:          .long 0x3ff
PDATA_val:          .long 0x0
PCONB_val:          .long 0x1ff
PDATB_val:          .long 0x0
PCONC_val:          .long 0xff55ff15  
PDATC_val:          .long 0x0
PUPC_val:           .long 0xffff
PCOND_val:          .long 0xaaaa
PDATD_val:          .long 0x0
PUPD_val:           .long 0xff
PCONE_val:          .long 0x200ab
PDATE_val:          .long 0x0
PUPE_val:           .long 0xff
PCONF_val:          .long 0x827ea
PDATF_val:          .long 0x63
PUPF_val:           .long 0x1e3
PCONG_val:          .long 0x0000
PDATG_val:          .long 0x0
PUPG_val:           .long 0x0
SPUCR_val:          .long 0x7
EXTINT_val:         .long 0x422
INTPND_val:         .long 0x0
INTMOD_val:         .long 0x0
INTMSK_val:         .long 0x07ffffff    // all interrupt disable
